//turn on, when showing results for compare
var compareMod = false;

//Arrays with results of compare
var compareResultOnlyTop = [];
var compareResultBoth = [];
var compareResultOnlyBot = [];

var compareResultBothRenamed = [];

var gotCompareWarnings=false;

var currentCompareBranch = null;
var compareBranchSnapshotController = null;
var compareController = null;

var TopWarningObjects={};

var renamedWarnings = {};

function fetchSvace2SvaceCompareResultsAndCompare(){
    if (compareController==null){
        setError("Something gone wrong: compare engine is not set up");
        return;
    }

    var url='/history/api?act=get_warnings_compare_svace2svace'+
        getProjectParameter(currentSvaceProject, '_1')+
        getBranchParameterFromString(compareController.getBranch(), '_1')+
        '&snapshot_id_1='+compareController.getSnapshot()+
        getProjectParameter(currentSvaceProject, '_2')+
        getBranchParameter(currentSvaceProject, '_2')+
        '&snapshot_id_2='+makeSnapshotIDParm(currentSvaceProject);


    $.ajax( {
            url: url,
            type: 'POST',
            dataType: 'json',
            cache: false,
            async: false,
            success: function (data, textStatus) {
                //data is already json
                if (data.status === "OK") {
                    compareResultsPlease(data);
                }
            },
            error: ajaxError,
            complete:function(){
                fetching = false;
                }
        });
}

function compareResultsPlease(Svace2SvaceWarnings){
	WarningObjectsWrap.WarningObjects={};
    var WarningObjects = WarningObjectsWrap.WarningObjects;

	compareMod = true;

    renamedWarnings = {};

    compareResultOnlyTop = Svace2SvaceWarnings.firstOnly;
    var countOnlyTop = compareResultOnlyTop.length;
    for(var i = 0; i < countOnlyTop; i++)
    {
        var warning = compareResultOnlyTop[i];
        makeWarningSortingData(warning);
        warning.project = currentSvaceProject;
        rememberWarning(warning, WarningObjects);
    }


    compareResultOnlyBot = Svace2SvaceWarnings.secondOnly;
    var countOnlyBot = compareResultOnlyBot.length;
    for(var i = 0; i < countOnlyBot; i++)
    {
        var warning = compareResultOnlyBot[i];
        makeWarningSortingData(warning);
        warning.project = currentSvaceProject;
        rememberWarning(warning, WarningObjects);
    }

    var countBoth = 0;
    compareResultBoth.length = 0;
    compareResultBothRenamed.length = 0;

    var renamedCount = 0;

    for(var i = 0; i < Svace2SvaceWarnings.common.length; i++)
    {
        var pair = Svace2SvaceWarnings.common[i];
        var warning = pair.first;
        compareResultBoth[countBoth] = warning;

        makeWarningSortingData(warning);
        warning.project = currentSvaceProject;
        rememberWarning(warning, WarningObjects);
        rememberWarning(pair.second, WarningObjects);

        if(pair.kind == "RENAME")
        {
            compareResultBoth[countBoth].renamedPreviousVersion = pair.second;
            renamedWarnings[countBoth] = pair.second;
            compareResultBothRenamed[renamedCount] = warning;
            renamedCount++;
        }
        countBoth++;
    }

    $('#firstAll').text("All ("+countOnlyTop+")");
    $('#bothAll').text("All ("+countBoth+", including " + renamedCount + " renamed)");
    $('#secondAll').text("All ("+countOnlyBot+")");

    $('#bothRenamed').text("Renamed ("+renamedCount+")");

    showFirstAll();
}




/*
 * Get warnings, compare it and generate results lists
 */
function fetchCompareResultsAndCompare(){
	if (compareController==null){
		setError("Something gone wrong: compare engine is not set up");
		return;
	}
	
	var CompareWarningObjectsWrap={WarningObjects:{}};
	
	var branchParam; 
	try {
		var proj = currentSvaceProject;
		currentSvaceProject.ui.branch_override=compareController.getBranch();
		branchParam = getBranchParameter(currentSvaceProject);
	} finally {
		delete currentSvaceProject.ui.branch_override;
	}
	
	
	fetchWarnings({
		container: CompareWarningObjectsWrap,
		displayWarnings: false,
		snapshotParam: compareController.getSnapshot(),
		branchParam: branchParam,
		successFunction: function(){
			compareResults(CompareWarningObjectsWrap);
		}
	});
}

function compareResults(CompareWarningObjectsWrap){

	var CompareWarningObjects = CompareWarningObjectsWrap.WarningObjects;
	var WarningObjects = WarningObjectsWrap.WarningObjects;


	if(!compareMod){
		clearObject(TopWarningObjects);
		for (prop in WarningObjects)
			if (WarningObjects.hasOwnProperty(prop))
				TopWarningObjects[prop]=WarningObjects[prop];
	}

	compareMod = true;
	
	compareResultOnlyBot.length = 0;
	compareResultBoth.length = 0;
	compareResultOnlyTop.length = 0;
	
	var countOnlyBot = 0;
	var countBoth = 0;
	var countOnlyTop = 0;
	var countOnlyTop = 0;



	for (prop in TopWarningObjects) {
		if (TopWarningObjects.hasOwnProperty(prop)) {
			if (CompareWarningObjects[prop]==undefined){
				//only top
				compareResultOnlyTop[countOnlyTop] = TopWarningObjects[prop];
				countOnlyTop++;
			}else{
				//both
				compareResultBoth[countBoth] = TopWarningObjects[prop];
				countBoth++;
			}
		}
	}

	for (prop in CompareWarningObjects) {
		if (CompareWarningObjects.hasOwnProperty(prop)) {
			if (TopWarningObjects[prop]==undefined){
				//only bot
				compareResultOnlyBot[countOnlyBot] = CompareWarningObjects[prop];
				countOnlyBot++;
			}else{
				//Already must be in both.
			}
		}
	}
	$('#firstAll').text("All ("+countOnlyTop+")");
	$('#bothAll').text("All ("+countBoth+")");
	$('#secondAll').text("All ("+countOnlyBot+")");
	
	showFirstAll();
}

function showWarnings(Warnings){
	clearDisplayedWarnings();
	WarningObjectsWrap.WarningObjects={};
	
	renderWarningGroups(Warnings, WarningObjectsWrap.WarningObjects, true);
}

function showFirstAll(){
	showWarnings(compareResultOnlyTop);
}

function showBothAll(){
	showWarnings(compareResultBoth);
}

function showSecondAll(){
	showWarnings(compareResultOnlyBot);
}

function showBothRenamed(){
	showWarnings(compareResultBothRenamed);
}

function stopCompareMod(){
	compareMod = false;
	$('#analyzeRezultsBox').css('top', '1.4em');
	$('#compareResults').hide();
	$('#compareBox').hide();
}


