function loadRolePermissions(roleID){
	list = $("#rolePermissionSelector");
	list.text("");
	managerRefreshPermissionsEx(list, roleID);
	list.append("<br><a id='addRolePermissionLink' href='javascript:addRolePermissionDialog("+roleID+");'>Add permission</a><div id='rolePermissionSpinnerDiv' style='display:inline;'></div>");
}

function managerRefreshPermissionsEx(list, roleID){
	list.html("Loading permission list...");
	permissions = loadPermissions(roleID);
	if (permissions!=null)
		managerDisplayPermissions(permissions, list, roleID);
	else
		list.text("Failed to load permissions list");
	$("#managementForm").dialog({position:{'my':'center', 'at':'center', 'of': window}});
}

function loadPermissions(roleID){
	var loadedPermissions = null;
	$.ajax({
		url : '/history/api?act=get_role_permission_list&role='+roleID,
		dataType : 'json',
		type : 'GET',
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				$("#managerStatus").text(
						"Failed to load permission list: " + data.error);
			} else {
				OK = true;
				loadedPermissions = data.permissions;
			}
		},
		error : ajaxError
	});
	return loadedPermissions;
}

svaceRolePermissions = [];
function managerDisplayPermissions(permissions, list, roleID) {
	svaceRolePermissions = permissions;
	list.html("");
	if (permissions.length > 0) {
		for (var i = 0; i < permissions.length; i++) {
			permission = permissions[i];
			
			permissionLink = renderPermission(permission);
			
			permissionLink += "<br/><font size=-2>";
			permissionLink += "<a href='javascript:deletePermission("+i+","+roleID+");'>[revoke]</a>";
			permissionLink += "</font><br/>";
			list.append(permissionLink);
		}
	} else {
		list.text("No permissions found on server for this role");
	}
}

function renderPermission(permission){
	result=""
	switch (permission.permission){
	case (0):
		result = "Can admin and access data in ";
		break;
	case (50):
		result = "Can modify data in ";
		break;
	case (100):
		result = "Can read data in ";
		break;
	default:
		return "Server returned broken permission";
	}
	
	switch (permission.permission_scope){
	case (0):
		result += "entire server.";
		break;
	case (1):
		result += "project group "+renderGroupForPermission(permission.permission_data)+" and sub-projects.";
		break;
	case (2):
		result += "project "+renderProjectForPermission(permission.permission_data)+".";
		break;
	default:
		return "Server returned broken permission";
	}
	return result;
}

function renderGroupForPermission(gID){
	//TODO: caching
	projectGroup = fetchProjectGroup(gID);
	if (projectGroup==null)
		return "[Unknown group ID="+gID+"]";
	return "["+projectGroup.name+"]";
}

function renderProjectForPermission(pID){
	//TODO: caching
	project = fetchProject(pID);
	if (project==null)
		return "[Unknown project ID="+pID+"]";
	return "["+project.project_name+"]";
}

function deletePermission(idx, role_id){
	managerStatus("");
	deletedPermission = svaceRolePermissions[idx];
	data = new Object();
	data.role_id = role_id;
	data.permission_scope = deletedPermission.permission_scope;
	data.permission_data = deletedPermission.permission_data;
	$.ajax({
		url : '/history/api?act=revoke_role_permission',
		dataType : 'json',
		type : 'POST',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				managerStatus("Failed to revoke permission: " + data.error);
			} else {
				OK = true;
				managerStatus("Permission revoked.");
			}
		},
		error : ajaxError
	});
	loadRolePermissions(role_id);
}

function addRolePermissionDialog(roleID){
	$('#addRolePermissionLink').hide();
	roleDivHTML = "<select id='permissionSpinner'><option value='100'>Read</option><option value='50'>Modify</option><option value='0'>Admin</option></select>";
	roleDivHTML += " on <select id='permissionScopeSpinner'><option value='0'>Server</option><option value='1'>Project group</option><option value='2'>Project</option></select>";
	roleDivHTML += "<div id='permissionProjectSpinnerDiv' style='display:inline;'><select id='permissionProjectSpinner'></select> from group </div>";
	roleDivHTML += " <select id='permissionGroupSpinner' style='display:inline;'></select>";
	roleDivHTML += "<input type='submit' id='rolePermissionCommit' value='Add permission!'/>";
	$('#rolePermissionSpinnerDiv').html(roleDivHTML);
	$('#permissionGroupSpinner').hide();
	$('#permissionProjectSpinnerDiv').hide();
	$('#permissionScopeSpinner').change(function(){
		switch ($('#permissionScopeSpinner').val()){
		case "0":
			$('#permissionGroupSpinner').hide();
			$('#permissionGroupSpinner').html("");
			$('#permissionProjectSpinnerDiv').hide();
			$('#permissionProjectSpinner').html("");
			break;
		case "1":
			$('#permissionProjectSpinnerDiv').hide();
			$('#permissionProjectSpinner').html("");
			spinner = $('#permissionGroupSpinner');
			spinner.change(function(){});
			spinner.show();
			spinner.html("");
			groups = fetchProjectGroups();
			if (groups==null){
				$('#addRolePermissionLink').show();
				$('#rolePermissionSpinnerDiv').text("&nbsp;Failed to load group list");	
			} else {
				for (i=0; i<groups.length; i++){
					spinner.append("<option value='"+groups[i].project_group_id+"'>"+escapeHTML(groups[i].project_group_name)+"</option>");
				}
			}
			break;
		case "2":
			$('#permissionProjectSpinnerDiv').show();
			projectSpinner = $('#permissionProjectSpinner');
			projectSpinner.html("");
			projectSpinner.prop("disabled", true);
			spinner = $('#permissionGroupSpinner');
			spinner.show();
			spinner.html("");
			spinner.change(function(){});
			groups = fetchProjectGroups();
			if (groups==null){
				$('#addRolePermissionLink').show();
				$('#rolePermissionSpinnerDiv').html("&nbsp;Failed to load group list");	
			}else if (groups.length==0){
				$('#addRolePermissionLink').show();
				$('#rolePermissionSpinnerDiv').html("&nbsp;No groups on server");	
			} else {
				for (i=0; i<groups.length; i++){
					spinner.append("<option value='"+groups[i].project_group_id+"'>"+escapeHTML(groups[i].project_group_name)+"</option>");
				}
				spinner.change(function(){
					projects = fetchProjectGroup(spinner.val());
					projectSpinner.html("");
					if (projects==null){
						$('#addRolePermissionLink').show();
						$('#rolePermissionSpinnerDiv').html("&nbsp;Failed to load project list");
					} else {
						projects = projects.projects;
						for (i=0; i<projects.length; i++){
							projectSpinner.append("<option value='"+projects[i].project_id+"'>"+escapeHTML(projects[i].project_name)+"</option>");
						}
						projectSpinner.prop("disabled", projects.length==0);
					}
				});
			}
			break;
		}
	});
	$('#rolePermissionCommit').click(function(){
		processAddPermissionSpinnerValues(roleID);
	});
}

function processAddPermissionSpinnerValues(roleID){
	permission = $('#permissionSpinner').val();
	scope = $('#permissionScopeSpinner').val();
	data = -1;
	if (scope==1)
		data = $('#permissionGroupSpinner').val();
	else if (scope==2)
		data = $('#permissionProjectSpinner').val();
	if (data==null){
		alert("looks like you have not selected project/group");
		return;
	}
		
	addRolePermission(roleID, scope, data, permission);
	$('#rolePermissionSpinnerDiv').hide();
	$('#addRolePermissionLink').show();
	loadRolePermissions(roleID);
}

function addRolePermission(role_id, scope, pdata, permission){
	managerStatus("");
	data = new Object();
	data.role_id = role_id;
	data.permission_scope = scope;
	data.permission_data = pdata;
	data.permission = permission;
	
	$.ajax({
		url : '/history/api?act=grant_role_permission',
		dataType : 'json',
		type : 'POST',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				managerStatus("Failed to grant permission: " + data.error);
			} else {
				OK = true;
				managerStatus("Permission granted");
			}
		},
		error : ajaxError
	});
}