function managerRefreshUsers(){
	$("#userSelector").html("Loading user list...");
	$.ajax({
		url : '/history/api?act=get_user_list',
		dataType : 'json',
		type : 'GET',
		async : true,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				$("#managerStatus").text("Failed to load user list: " + data.error);
				$("#userSelector").html("<a href='javascript:updateSelf();'>Update own password</a>");
			} else {
				OK = true;
				managerDisplayUsers(data.users);
			}
			centerManagement();
		},
		error : function (data, textstatus, error){
			ajaxError(data, textstatus, error);
			$("#managerStatus").text("Failed to load user list");
			$("#userSelector").html("<a href='javascript:updateSelf();'>Update own password</a>");
		}
	});
}

svaceUsers = [];
function managerDisplayUsers(users) {
	svaceUsers = users;
	userlist = $("#userSelector");
	$("#userSelector").html("");
	if (users.length > 0) {
		for (var i = 0; i < users.length; i++) {
			user = users[i];
			userlist.append("<a href='javascript:loadUserRoles(" + user.user_id + ");' id='User_"+user.user_id+"'>"
					+ escapeHTML(user.user_name) + "</a><br/><font size=-2>" +
					"<a href='javascript:editUser(" + i + ");'>[update pasword]</a>&nbsp" +
					"<a href='javascript:deleteUser(" + i + ");'>[delete]</a>" +
							"</font><br/>");
		}
	} else {
		userlist.text("No users found on server. How did you manage to log in? :3");//
	}
}

currentlyEditedUser = undefined;
function editUser(idx){
	currentlyEditedUser = svaceUsers[idx];
	updateUserShow(currentlyEditedUser.user_name);
}

function deleteUser(idx){
	managerStatus("");
	deletedUser = svaceUsers[idx];
	data = new Object();
	data.user_id = deletedUser.user_id;
	$.ajax({
		url : '/history/api?act=delete_user',
		dataType : 'json',
		type : 'POST',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				managerStatus("Failed to delete user: " + data.error);
			} else {
				OK = true;
				managerStatus("User deleted");
			}
		},
		error : ajaxError
	});
	managerRefreshUsers();
}


function addUserShow(){
	$("#addUserLink").hide();
	$("#newUserSubmit").show();
	$("#updateUserSubmits").hide();
	$("#newUserLogin").val("");
	$("#newUserLogin").prop("disabled",false);
	$("#newUserPass").val("");
	$("#userForm").show();
}

function addUserSubmit(){
	managerStatus("");
	data = new Object();
	data.login = $("#newUserLogin").val();
	data.pass = $("#newUserPass").val();
	$.ajax({
		url : '/history/api?act=create_user',
		dataType : 'json',
		type : 'POST',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				$("#managerStatus").text("Failed to create user: " + data.error);
			} else {
				OK = true;
				managerStatus("User created");
			}
		},
		error : ajaxError
	});
	$("#addUserLink").show();
	$("#userForm").hide();
	managerRefreshUsers();
}

function updateSelf(){
	updateUserShow($('#userName').text());
	currentlyEditedUser = new Object();
	currentlyEditedUser.user_id = "self";
}

function updateUserShow(name){
	$("#addUserLink").hide();
	$("#newUserSubmit").hide();
	$("#updateUserSubmits").show();
	$("#newUserLogin").val(name);
	$("#newUserLogin").prop("disabled",true);
	$("#newUserPass").val("");
	$("#userForm").show();
}

function updateUserSubmit(){
	managerStatus("");
	data = new Object();
	data.user_id = currentlyEditedUser.user_id;
	data.pass = $("#newUserPass").val();
	$.ajax({
		url : '/history/api?act=modify_user',
		dataType : 'json',
		type : 'POST',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
				managerStatus("Failed to update user: " + data.error);
			} else {
				OK = true;
				managerStatus("User data updated");
			}
		},
		error : ajaxError
	});
	$("#addUserLink").show();
	$("#userForm").hide();
}

function cancelUpdateUser(){
	$("#addUserLink").show();
	$("#userForm").hide();
}

function loadUserRoles(userID){
	list = $("#userRoleSelector");
	list.text("");
	managerRefreshRolesEx(list, userID, false);
	list.append("<br><a id='addUserRoleLink' href='javascript:addUserRoleDialog("+userID+");'>Add role</a><div id='userRoleSpinnerDiv' style='display:inline;'></div>");
}