var svaceProjectGroups = [];

var currentProjectGroup = undefined;
var displayedSvaceProjects = [];

// If set to true, we are in the multiple-projects mode, so that in particular
// currentSvaceProject is not the only project being displayed, but instead
// a mutable value that traverses the projects in svaceProjects
// (see svace.loadFromAll.js)
var loadFromAllProjects = false;
var currentSvaceProject = undefined;

var COMPARE_PROJECTS={
	project_1: null,
	project_2: null,
}

var GROUP_SIMILAR = false;

function showProjectSelectionDialog(is_second_project) {
	if (!isLoggedIn()) {
		forceLogin("Log in please");
		return;
	}

	if (is_second_project==undefined){
		is_second_project = false;
	}
	if (COMPARE_MODE){
		if (is_second_project){
			$('#comparePrjHeadr').text("Select second project");
		} else {
			drop(SVACE_CLEANUP_LOGOUT);//Bad naming; we 'logged out' from old project actually.
			$('#comparePrjHeadr').text("Select first project");
			COMPARE_PROJECTS.project_1=null;
			COMPARE_PROJECTS.project_2=null;
		}
	} else {
		drop(SVACE_CLEANUP_LOGOUT);//Bad naming; we 'logged out' from old project actually.
		$('#comparePrjHeadr').text("Select project");
	}
	updateTitle();
	$("#projectSelectionForm").dialog("open");
	loadProjectGroupsEx($("#projectGroupSelector"), $("#projectSelector"), false);
}

lastProjectViewGroupList = null;
lastProjectViewProjectList = null;
lastProjectViewIsManager = null;

function loadProjectGroupsEx(pgList, pList, isManager) {
	lastProjectViewGroupList = pgList;
	lastProjectViewProjectList = pList;
	lastProjectViewIsManager = isManager;
	loadProjectGroups();
}

function loadProjectGroups() {
	lastProjectViewGroupList.text("Loading project groups...");
	lastProjectViewProjectList.html("");
	lastProjectViewProjectList.hide();

	var groups = fetchProjectGroups();
	if (groups==null)
		lastProjectViewGroupList.text("Failed to retrieve groups list");
	else
		displayProjectGroups(groups);
}

function fetchProjectGroups() {
	var fetchedProjectsGroups = null;
	$.ajax({
		url : '/history/api?act=get_projects',
		dataType : 'json',
		type : 'GET',
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				OK = true;
				fetchedProjectsGroups = data.project_groups;
			}
		},
		error : ajaxError
	});
	return fetchedProjectsGroups;
}

function fetchProjectGroup(project_group_id) {
	var data = new Object();
	data.project_group_id = project_group_id;
	var fetchedProjectsGroup = null;
	$.ajax({
		url : '/history/api?act=get_project_group_info',
		dataType : 'json',
		type : 'GET',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				OK = true;
				fetchedProjectsGroup = data.project_group;
				var svaceProjects = fetchedProjectsGroup.projects;
				if (svaceProjects.length > 0) {
					//creating field where browser can store local project-related data like branches, builds, etc
					for (var i = 0; i < svaceProjects.length; i++) {
						svaceProjects[i].ui={};
					}
				}
			}
		},
		error : ajaxError
	});
	return fetchedProjectsGroup;
}

function fetchProject(project_id) {
	var data = new Object();
	data.project_id = project_id;
	var fetchedProject = null;
	$.ajax({
		url : '/history/api?act=get_project_info',
		dataType : 'json',
		type : 'GET',
		data : data,
		async : false,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				OK = true;
				fetchedProject = data.project;
			}
		},
		error : ajaxError
	});
	return fetchedProject;
}


function displayProjectGroups(groups) {
	svaceProjectGroups = groups;
	var pglist = lastProjectViewGroupList;
	pglist.text("");
	if (groups.length > 0) {
		for (var i = 0; i < groups.length; i++) {
			var group = groups[i];
			var description=group.project_group_description
			if (description=="")
				description="";
			var pgLinkID = (lastProjectViewIsManager?"mgr_":"")+"PG_"+i;
			var pgEntry = "<a href='javascript:;' id='"+pgLinkID+"'>"
					+ escapeHTML(group.project_group_name) + "</a><br/><font size=-2><i>"
					+ escapeHTML(description) + "</i>";
			
			if (lastProjectViewIsManager){
				pgEntry+="<a href='javascript:;' id='"+pgLinkID+"_edit'>[edit]</a>&nbsp" +
				"<a href='javascript:;' id='"+pgLinkID+"_delete'>[delete]</a>";				
			}
			pgEntry += "</font><br/>";
			
			pglist.append(pgEntry);
			$('#'+pgLinkID).click([i], function(data){
				loadProjects(data.data[0]);
			});
			if (lastProjectViewIsManager){
				$('#'+pgLinkID+"_edit").click([i], function(data){
					editProjectGroup(data.data[0]);
				});
				$('#'+pgLinkID+"_delete").click([i], function(data){
					deleteProjectGroup(data.data[0]);
				});
			}
		}
	} else {
		pglist.text("No project groups registered on server :(");
	}
	if (lastProjectViewIsManager)
		pglist.append("<br/><a href='javascript:;' id='addProjectGroupLink' onclick='addProjectGroup();'>New project group</a>");
	$("#projectSelectionForm").dialog({position:{'my':'center', 'at':'center', 'of': window}});
}

function addProjectGroup(){
	var newpgname = prompt("Please enter project group name", "");
	if (newpgname==null)
		return;
	var newpgdescription = prompt("And description", "");
	if (newpgdescription==null)
		return;
	lastProjectViewGroupList.text("Creating project group...");
	$.ajax({
		url : '/history/api?act=create_project_group',
		dataType : 'json',
		type : 'POST',
		data: 'project_group_name='+encodeURIComponent(newpgname)+'&project_group_desc='+encodeURIComponent(newpgdescription),
		async : true,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			lastProjectViewGroupList.text("");
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				loadProjectGroups();
			}
		},
		error : ajaxError
	});
}

function editProjectGroup(group_id){
	var group = svaceProjectGroups[group_id];
	if (group==null){
		setError("Local internal error: no such editable group found");
	}
	var newGroupData = new Object(); 
	newGroupData.project_group_name = prompt("Please enter project group name", group.project_group_name);
	if (newGroupData.project_group_name==null)
		return;
	newGroupData.project_group_description = prompt("And description", group.project_group_description);
	if (newGroupData.project_group_description==null)
		return;
	newGroupData.project_group_id = group.project_group_id;
	$.ajax({
		url : '/history/api?act=modify_project_group',
		dataType : 'json',
		type : 'POST',
		data: newGroupData,
		async : true,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				loadProjectGroups();
			}
		},
		error : ajaxError
	});
}

function deleteProjectGroup(group_id){
	if (prompt("Enter 'really' if you really want to delete this project directory: this action cannot be undone!")!="really"){
		setError("Project directory removing cancelled!");
		return;
	}
	var group = svaceProjectGroups[group_id];
	if (group==null){
		setError("Local internal error: no such delitable group found");
	}
	var data = new Object(); 
	data.project_group_id = group.project_group_id;
	$.ajax({
		url : '/history/api?act=delete_project_group',
		dataType : 'json',
		type : 'POST',
		data: data,
		async : true,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				loadProjectGroups();
			}
		},
		error : ajaxError
	});
}

var last_displayed_group_id=undefined;
function loadProjects(group_id){
	currentProjectGroup = group_id;
	lastProjectViewProjectList.show();
	lastProjectViewProjectList.html("Loading projects...");
	var group = svaceProjectGroups[group_id];
	if (group==null){
		setError("Local internal error: no such group found.");
	}
	last_displayed_group_id = group_id;
	
	var projectGroup = fetchProjectGroup(group.project_group_id);
	if (projectGroup!=null)
		displayProjects(projectGroup);
	else
		lastProjectViewProjectList.text("Failed to load project list.");
}

function displayProjects(project_group) {
	displayedSvaceProjects = project_group.projects;
	var pglist = lastProjectViewProjectList;
	pglist.text("");
	if (displayedSvaceProjects.length > 0) {
		for (var i = 0; i < displayedSvaceProjects.length; i++) {
			var project = displayedSvaceProjects[i];
			description=project.project_description
			if (description=="")
				description="";
			
			pLinkID = (lastProjectViewIsManager?"mgr_":"")+"prj_"+i;

			pEntry = "<a href='javascript:;' id='"+pLinkID+"'>"
			+ escapeHTML(project.project_name) + "</a><br/><font size=-2><i>"
			+ escapeHTML(description) + "</i>";
			
			if (lastProjectViewIsManager){
				pEntry+="<a href='javascript:;' id='"+pLinkID+"_branches'>[branches]</a>&nbsp";				
				pEntry+="<a href='javascript:;' id='"+pLinkID+"_edit'>[edit]</a>&nbsp" +
				"<a href='javascript:;' id='"+pLinkID+"_delete'>[delete]</a>";
			}
			
			pEntry+="</font><br/>";
			
			pglist.append(pEntry);
			
			if (lastProjectViewIsManager){
				$('#'+pLinkID+"_edit").click([i], function(data){
					editProject(data.data[0]);
				});
				$('#'+pLinkID+"_delete").click([i], function(data){
					deleteProject(data.data[0]);
				});
				$('#'+pLinkID+"_branches").click([i], function(data){
					editBranches(data.data[0]);
				});
			} else {
				$('#'+pLinkID).click([i], function(data){
					loadProject(data.data[0]);
				});
			}
		}
		if (!lastProjectViewIsManager)
			displayLoadAllProjectsButton();
	} else {
		pglist.text("No projects registered in this group :(");
	}
	if (lastProjectViewIsManager)
		pglist.append("<br/><br/><a href='javascript:;' id='addProject' onclick='addProject();'>New project</a>");
	$("#projectSelectionForm").dialog({position:{'my':'center', 'at':'center', 'of': window}});
}

function displayLoadAllProjectsButton() {
	if (!COMPARE_MODE){
		lastProjectViewProjectList.append("<br/><b><a href='javascript:loadAllProjects();' id='loadAllProjectsLink'>Show warnings for all projects</a></b><br/>");
	}
}

function addProject(){
	var newpname = prompt("Please enter project name", "");
	if (newpname==null)
		return;
	var newpdescription = prompt("And description", "");
	if (newpdescription==null)
		return;
	lastProjectViewProjectList.text("Creating project...");
	$.ajax({
		url : '/history/api?act=create_project',
		dataType : 'json',
		type : 'POST',
		data: 'project_name='+encodeURIComponent(newpname)+'&project_desc='+encodeURIComponent(newpdescription)+'&project_group='+svaceProjectGroups[last_displayed_group_id].project_group_id,
		async : true,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			lastProjectViewProjectList.text("");
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				loadProjects(last_displayed_group_id);
			}
		},
		error : ajaxError
	});
}

function addBranch(event) {	
	if (event.data == null) {
		console.log("Invalid branch list");
		return;
	}
	const context = event.data;
	if (context.branches == null || context.branches.forEach == null) {
		console.log("Invalid branch list");
		return;
	}
	const name = prompt("Please enter new branch name", "");
	let found = false;
	context.branches.forEach(item => {
		if (item.name === name) {
			found = true;
		}
	})
	if (!found) {		
		const sourceBranch=encodeURIComponent(context.source);
		const targetBranch=encodeURIComponent(name);
		const url = '/history/api?act=modify_branches'
		const data = "&project_id=" + context.project_id +
					 '&source_branch='+sourceBranch +
					 '&target_branch='+targetBranch +
					 '&operation=add';
		console.log('Add branch request: ' + data);
		$.ajax( {
			url:url,
			dataType: 'json',
			type: 'POST',
			data: data,
			async: true,
			cache: false,
			success: function (data, textStatus) {
				if (data.status != "OK") {
					setError("Error:"+data.error);
				} else {
					context.branches.push({name: name});
					fillBranchesList(context);
				}
			},
			error: ajaxError			
		});		
	}
}

function removeBranch(event) {
	if (event.data == null) {
		console.log("removeBranch: Invalid event");
		console.log(event);
		return;
	}	
	const context = event.data;
	if (context.branches == null || context.source == null) {
		console.log("removeBranch: no branches");
		return;
	}	
	const sourceBranch=encodeURIComponent(context.source);	
	const url = '/history/api?act=modify_branches'
	const data = "&project_id=" + context.project_id +
				 '&source_branch='+sourceBranch +
				 '&operation=remove';
	console.log('Remove branch request: ' + data);
	$.ajax( {
		url:url,
		dataType: 'json',
		type: 'POST',
		data: data,
		async: true,
		cache: false,
		success: function (data, textStatus) {
			if (data.status != "OK") {
				setError("Error:"+data.error);
			} else {
				context.branches = context.branches.filter(item => item.name !== context.source);				
				fillBranchesList(context);
			}
		},
		error: ajaxError			
	});
}

function fillBranchesList(context) {
	$('#branches-list').empty();	
	$('#branches-list').append(`<li><div><span>master </span><a href="javascript:;" id="br-add-0">clone</a></div></li>`);
	$('#br-add-0').click({
		...context,
		source: 'master'
	}, addBranch);
	let index = 1;
	context.branches.forEach(item => {
		if (item.name !== "master") {			
			const add = `<a href="javascript:;" id="br-add-${index}">clone</a>`;
			const remove = `<a href="javascript:;" id="br-remove-${index}">remove</a>`;		
			const element = `<li><div><span>${item.name}  </span>${add}<span> </span>${remove}</div></li>`;
			$('#branches-list').append(element);
			$('#br-add-' + index).click({
				...context,
				source: item.name
			}, addBranch)			
			$('#br-remove-' + index).click({
				...context,
				source: item.name
			}, removeBranch)
			++index;
		}
	});
}

function editBranches(project_id) {
	var project = displayedSvaceProjects[project_id];
	if (project == null) {
		setError("Local internal error: no such editable project found");
	}
	$.ajax( {
		url:'/history/api?act=branches'+getProjectParameter(project),
		dataType: 'json',
		type: 'GET',
		cache: false,
		success: function (data, textStatus) {
			if (data.status != "OK") {
				setError("Error:"+data.error);
			} else {				
				const context = { project_id: project.project_id,  branches: data.branches};
				fillBranchesList(context);
				$(".edit-branches-overlay").addClass("active");
			}
		},
		error: ajaxError,
		complete: function(){
			console.log("Complete");
		}
	});	
	$("#edit-branches-close").on("click", function(ev) {
		$(".edit-branches-overlay").removeClass("active");
	});		
}

function editProject(project_id){
	var project = displayedSvaceProjects[project_id];
	if (project==null){
		setError("Local internal error: no such editable project found");
	}
	var newProjectData = new Object(); 
	newProjectData.project_name = prompt("Please enter project name", project.project_name);
	if (newProjectData.project_name==null)
		return;
	newProjectData.project_description = prompt("And description", project.project_description);
	if (newProjectData.project_description==null)
		return;
	newProjectData.project_id = project.project_id;
	lastProjectViewProjectList.text("Modifying project...");
	$.ajax({
		url : '/history/api?act=modify_project',
		dataType : 'json',
		type : 'POST',
		data: newProjectData,
		async : true,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			lastProjectViewProjectList.text("");
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				loadProjects(last_displayed_group_id);
			}
		},
		error : ajaxError
	});
}

function deleteProject(project_id){
	if (prompt("Enter 'really' if you really want to delete this project: this action cannot be undone!")!="really"){
		setError("Project removing cancelled!");
		return;
	}
	var project = displayedSvaceProjects[project_id];
	if (project==null){
		setError("Local internal error: no such delitable project found");
	}
	var data = new Object(); 
	data.project_id = project.project_id;
	lastProjectViewProjectList.text("Deleting project...");
	$.ajax({
		url : '/history/api?act=delete_project',
		dataType : 'json',
		type : 'POST',
		data: data,
		async : true,
		cache : false,
		success : function(data, textStatus) {
			// data is already json
			lastProjectViewProjectList.text("");
			if (data.status != "OK") {
				setError("Error:" + data.error);
			} else {
				loadProjects(last_displayed_group_id);
			}
		},
		error: ajaxError
	});
}

function updateCompareConfigDialog()
{
	var p1 = COMPARE_PROJECTS.project_1;
	var p2 = COMPARE_PROJECTS.project_2;
	p1.ui.controller=makeBranchController(p1, $("#ac_branch_first"), null, $("#ac_snapshot_first"), null);
	p2.ui.controller=makeBranchController(p2, $("#ac_branch_second"), null, $("#ac_snapshot_second"), null);
}

function loadProject(local_project_id) {
	loadFromAllProjects = false;
	if (COMPARE_MODE){
		if (COMPARE_PROJECTS.project_1==null){
			COMPARE_PROJECTS.project_1 = displayedSvaceProjects[local_project_id];
			if (COMPARE_PROJECTS.project_1==null){
				setError("Local internal error: no such project found");
				return;
			} else {
				showProjectSelectionDialog(true);
				return;
			}
		} else {
			COMPARE_PROJECTS.project_2 = displayedSvaceProjects[local_project_id];
			if (COMPARE_PROJECTS.project_2==null){
				setError("Local internal error: no such project found");
				return;
			}
			updateCompareConfigDialog();
			$("#compareConfigDialog").dialog("open");
			return;
		}
	} else {
		currentSvaceProject = displayedSvaceProjects[local_project_id];
		if (currentSvaceProject==null){
			setError("Local internal error: no such project found");
		}
		$("#WarnProjectName").parent("td").parent("tr").hide();
	}
	projectSelected();
}

function projectSelected(){
	GROUP_SIMILAR = $('#groupSimilar').is(':checked');
	$("#WarnProjectName").parent("td").parent("tr").hide();
//	document.getElementById('WarnProjectRow').style.display = 'none';
	document.getElementById('svresTool').style.display = 'inline';
	document.getElementById('compareToolBox').style.display = 'inline';
	$("#projectSelectionForm").dialog("close");
	if (COMPARE_MODE){
		$("#compareConfigDialog").dialog("close");
	}
	
	drop(SVACE_CLEANUP_PROJECT);
	$("#userBuild").show();
	$("#compareUserBuild").show();
	
	fetchBranchesAndSnapshots();
	updateTitle();
} 

function loadAllProjects() {
	drop(SVACE_CLEANUP_SWITCHPROJECTGROUP);
	loadFromAllProjects = true;

	updateTitle();
	
	makeSnapshotController(null, $("#userBuild"));
	makeSnapshotController(null, $("#compareUserBuild"));

	$("#userBuild").hide();
	$("#compareUserBuild").hide();
	
	$("#WarnProjectName").parent("td").parent("tr").show();
	$("#statsArea").empty();

	document.getElementById('svresTool').style.display = 'none';
	document.getElementById('compareToolBox').style.display = 'none';

	$("#projectSelectionForm").dialog("close");

	allDisplayedProjects = displayedSvaceProjects;

	fetchBranchesAndSnapshots();
}
