function selectionTool() {
    var name = $('#selectionToolName').val();
    var size = parseInt($('#selectionToolSize').val());

    if (isNaN(size) || size <= 0) {
        size = Number.MAX_VALUE;
    }

    selectWithSeed(name, size);
}

if(typeof(String.prototype.trim) === "undefined")
{
    String.prototype.trim = function() 
    {
        return String(this).replace(/^\s+|\s+$/g, '');
    };
}

// FIXME: common code with loadFromAll.js
// @param 'name' is a seed
function selectWithSeed(name, size) {
    var filter_owner = $("#selectionToolAssigneeFilter").val();
    var filter_unclassified = $("#selectionToolOnlyUnclassifiedFilter").prop("checked");
    var filter_checkers_action = $('#selectionToolCheckerFilterAction').val();
    var filter_checkers_list = $('#selectionToolCheckerFilterArea').val().split('\n');
    var has_user_filter = $("#selectionToolConsiderSelectionAssignee").is(':checked');
    var filter_warnings_ids = [];
    
    {
    	var filter_ids= $('#selectionToolIDFilterArea').val().split('\n');
    	for (var i=0; i < filter_ids.length; i++) {
    		var id = filter_ids[i].trim(); 
    		if (id.length != 0)
    			filter_warnings_ids.push(id);
    	}
    }
    
    var all_hashes = [];
    var hash2id = [];
    var WarningObjects = WarningObjectsWrap.WarningObjects;
    for (var warn_id in WarningObjects) {
        if (selectionToolFilter(WarningObjects[warn_id], has_user_filter, filter_owner, filter_unclassified, filter_checkers_action, filter_checkers_list, filter_warnings_ids)) {
            var hash = MD5(name + warn_id);
            all_hashes.push(hash);
            hash2id[hash] = warn_id;
        }
    }
    
    all_hashes.sort();

    var warningsToDisplay = {};
    for (var i = 0; i < all_hashes.length && size > 0; ++i) {
        var warnId = hash2id[all_hashes[i]];
        warningsToDisplay[warnId] = WarningObjects[warnId];
        --size;
    }

    redrawWarnings(warningsToDisplay);
}

function selectionToolFilter(Warning, has_user_filter, filter_owner, filter_unclassified, filter_checkers_action, filter_checkers_list, filter_warnings_ids) {
	if (filter_warnings_ids.length>0) {
		if (filter_warnings_ids.indexOf(Warning.warning_id) == -1){
			return false;
		}
	}
    // Checkers group: critical, major or all
    var checkerName = getCheckerName(Warning.checker_id);

    // Only assigned to:
    if(has_user_filter)
    {
       	var owner = Warning.attributes.user_attributes.user_owner || "";
       	if (filter_owner != owner)
           	return false;
    }

    // Only unclassified:
    if (filter_unclassified) {
        classification_status = Warning.attributes.classification_id || "Undecided";
        if (classification_status != "Undecided")
            return false;
    }
    
	if (filter_checkers_action !== 'disabled'){
		var checkerInFilterList = false;
		for (var i=0; i<filter_checkers_list.length; i++) {
			var filterItem = filter_checkers_list[i].trim();
			if (filterItem === '')
				continue;
			if (checkerName === filterItem)
				checkerInFilterList = true;
		}

		if ((filter_checkers_action === 'retain')&&(!checkerInFilterList))
			return false;
		if ((filter_checkers_action === 'remove')&&(checkerInFilterList))
			return false;
	}

    return true;
}

function redrawWarnings(warningsToDisplay) {
	clearDisplayedWarnings();

    var toProcess = [];
    for (var Warning in warningsToDisplay)
    	toProcess.push(warningsToDisplay[Warning]);
    
    renderWarningGroups(toProcess, WarningObjectsWrap.WarningObjects, true);
/*    for (var warnId in warningsToDisplay) {
        var Warning = warningsToDisplay[warnId];

        getWarningGroupBox(Warning.checker_id, warningsToDisplay);
        
        var warnClassCounter = $('#ch_'+Warning.checker_id+'_counter');
        warnClassCounter.text(parseInt(warnClassCounter.text())+1);
    }*/

    countAndDisplayStats(warningsToDisplay, true);
}

function selectionToolResetButton() {
    redrawWarnings(WarningObjectsWrap.WarningObjects);
}

