function ajaxError(data, textstatus, error) {
	if ((data.responseText !== "")&&(data.responseText !== undefined)) {
		var response = JSON.parse(data.responseText);
		if (response.error!=null)
			error = response.error;
		if (response.authError==1)
			forceLogin(error);
	} else {
		if (error=="")
			error = "Connection error";
	}
	setError(error);
	fetching = false;
}

var errorFormKey=null;
function setError(message) {
	console.log("setError: " + message);

/*	var stackTrace = undefined;
	if (message!=null && message.stack!=undefined)
		stackTrace = message.stack;
	else
		stackTrace = new Error().stack;
	console.log("trace: " + stackTrace);*/

	var localErrorFormKey = new Date().getTime();
	$("#errorForm").text(message);
	$("#errorForm").show();
	setTimeout(function() {
		if (localErrorFormKey==errorFormKey)
			$("#errorForm").hide();
	}, 5000);
	errorFormKey = localErrorFormKey;
}

function checkSubmit(e)
{
	/*I faced a problem in opera: when you click 'logout' link and then enter credentials and then press 'Enter' to login,
	 *this 'Enter' is somehow sent to 'logout' link (possibly due to it is count as 'active' link. TODO: FIX)*/
	
	if(e && ((e.keyCode == 13)||(e.keyCode==10)))
	{
		processLogin();
	}
}

function insertInIDOrder(container, newElement, sortingID, desc) {
	if (desc==undefined)
		desc = false;
	var children=container.childNodes;
	var newID = newElement.getAttribute('id');
	newElement.setAttribute('sortingID', sortingID);
	var done = false;
	if (newID!=null)
		for (var i=0; (i< children.length)&&(!done); i++) {
			var sibling=children[i];
			if(sibling.attributes!=null) {
				var res;
				var siblingSSID=sibling.getAttribute('sortingID');
				if (desc){
					res=(siblingSSID.localeCompare(sortingID)<0);
				} else {
					res=(siblingSSID.localeCompare(sortingID)>0);
				}
				if (res) {
					container.insertBefore(newElement, sibling);
					done = true;
				}
			}
		}
	if (!done)
		container.appendChild(newElement);
}

function escapeHTML(data){
    return $('<div/>').text(data).html(); //send all complains there => http://stackoverflow.com/questions/24816/escaping-html-strings-with-jquery
}

function getBranchParameterFromString(branch, suffix){
	if (suffix==undefined)
		suffix='';
	return "&stream_id"+suffix+"="+encodeURIComponent(branch);
}

function getBranchParameter(proj, suffix){
	var branch;
	if (proj.ui.branch_override!=undefined){
		branch=proj.ui.branch_override;
		//this is hacky one-time field. We used it: we will delete it.
		delete proj.ui.branch_override;
	} else {
		 branch = proj.ui.controller.getBranch();
	}
	return getBranchParameterFromString(branch, suffix);
}

function getProjectParameter(proj, suffix){
	if (suffix==undefined)
		suffix='';
	if (proj==null){
		if (loadFromAllProjects)
			throw new Error("bad getProjectParameter");
		showProjectSelectionDialog();
		throw null;
	}
	return "&project_id"+suffix+"="+proj.project_id;
}

function myout(msg) {
	if (window.console && console.log) {
		console.log(msg);
	}
}

function updateTitle(){
	title = "Svace history server";
	if (loadFromAllProjects){
		title += " - multiple projects";
	} else if (COMPARE_MODE) {
		title += " - compare mode"
	} else {
		if (currentSvaceProject!=null){
			title += " - "+currentSvaceProject.project_name;
		}
	}
	if (lastLocation != null){
		title += " - "+lastLocation.short_name;
	} 
	document.title = title;
}

function toggleMenuElem(id) {
	$(".togglableMenuElem").each(function(index, elem)
	{
		if(elem.id == id)
			$(elem).toggle();
		else
			$(elem).hide();
	});
}	

function toggleMenuElemLvl2(id) {
	$(".togglableMenuElemLvl2").each(function(index, elem)
	{
		if(elem.id == id)
			$(elem).show();
		else
			$(elem).hide();
	});
}	

function updateAssignForm(){
	$("#assignWarnStats").text(Object.keys(DisplayedWarnings).length);
}

//-----Request interruption

$.xhrPool = [];
$.xhrPool.abortAll = function() {
    $(this).each(function(idx, jqXHR) {
        jqXHR.abort();
    });
};

$.ajaxSetup({
    beforeSend: function(jqXHR) {
        $.xhrPool.push(jqXHR);
    },
    complete: function(jqXHR) {
        var index = $.xhrPool.indexOf(jqXHR);
        if (index > -1) {
            $.xhrPool.splice(index, 1);
        }
    }
});

function showWarningDebug(){
	if (currentWarning==null)
		return;
	var warning = currentWarning;
	var report="";
	var func_name="undefined";
	var path = warning.location.file_path;
	var line = warning.location.line;
	var proj = warning.project;
	
/*	var snapshotData;
	var dxrOverride = warning.location.snapshot_override;
	if (dxrOverride == undefined)
		snapshotData = makeSnapshotIDParm(proj);
	else
		snapshotData = dxrOverride;
	{
		$.ajax( {
			url:'/history/api?act=get_tokens&file='+path+'&snapshot_id='+snapshotData+getProjectParameter(proj)+getBranchParameter(proj)+'&end_line='+line,
			dataType: 'json',
			cache: false,
			async: false,
			success: function (data, textStatus) {
				var tokens = data.tokens;
				var lastFunctionLine=-1;
				for (var idx=0; idx<tokens.length; idx++){
					var token = tokens[idx];
					if ((token.type==2)&&(true)){//it is function. How the hell should check it is definition?!!!
						if (token.location.line>lastFunctionLine){
							lastFunctionLine = token.location.line;
							func_name="";
						}
					}
				}
			},
			error: ajaxError
		});
	}*/
	report+="#Warning debug data\n"
	report+="project="+proj.project_name+"\n";
//	report+="function="+func_name+"\n";
	report+="file="+path+"\n";
	report+="line="+line+"\n";
	report+="hash="+warning.location.hash+"\n\n\n";
	report+="checker="+getCheckerName(warning.checker_id)+"\n";
	report+="warning_id="+warning.warning_id;
	
	alert(report);
}
